local DataGrid = Yague.DataGrid
local context = UI.CreateContext("mainFrame")
local icon = UI.CreateContext("Syn_minimapIcon")

local mainWindow = EnKai.uiCreateFrame("nkWindowModern", "Syn.UI.MainWindow", context)
local optionsPanel = UI.CreateFrame("Frame", "Syn.OptionsPanel", mainWindow)
local Syn_minimapIcon = UI.CreateFrame("Texture", "Icon", icon)
local tankIcon = UI.CreateFrame("Texture", "Tank Icon", mainWindow)
local tankCheck = UI.CreateFrame("RiftCheckbox", "tankCheck", mainWindow)
local healerIcon = UI.CreateFrame("Texture", "Healer Icon", mainWindow)
local healerCheck = UI.CreateFrame("RiftCheckbox", "healerCheck", mainWindow)
local damageIcon = UI.CreateFrame("Texture", "Damage Icon", mainWindow)
local damageCheck = UI.CreateFrame("RiftCheckbox", "damageCheck", mainWindow)
local supportIcon = UI.CreateFrame("Texture", "Support Icon", mainWindow)
local supportCheck = UI.CreateFrame("RiftCheckbox", "supportCheck", mainWindow)
	
local clientName = UI.CreateFrame("Text", "Clients Name", mainWindow)
local clientPrestige = UI.CreateFrame("Text", "Clients Prestige", mainWindow)
local clientNoteLabel = UI.CreateFrame("Text", "Clients Note Label", mainWindow)
local clientNoteLabel2 = UI.CreateFrame("Text", "Clients Note Label2", mainWindow)
local clientNote = UI.CreateFrame("RiftTextfield", "Clients Broadcast Note", mainWindow)


mainWindow:SetTitle("Synergy")
mainWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)
mainWindow:SetAlpha(1)
mainWindow:SetCloseable(true)
mainWindow:SetDragable(true)
mainWindow:SetHeight(600)
mainWindow:SetWidth(1000)
	
optionsPanel:SetPoint("CENTER", mainWindow, "CENTER", 360, 5)
optionsPanel:SetLayer(4)
optionsPanel:SetHeight(545)
optionsPanel:SetWidth(250)
optionsPanel:SetBackgroundColor(0,0,0,0.8)

tankIcon:SetPoint("CENTER", optionsPanel, "CENTER", -80, -230)
healerIcon:SetPoint("CENTER", optionsPanel, "CENTER", -27, -230)
damageIcon:SetPoint("CENTER", optionsPanel, "CENTER", 26, -230)
supportIcon:SetPoint("CENTER", optionsPanel, "CENTER", 79, -230)
tankCheck:SetPoint("CENTER", optionsPanel, "CENTER", -77, -195)
healerCheck:SetPoint("CENTER", optionsPanel, "CENTER", -24, -195)
damageCheck:SetPoint("CENTER", optionsPanel, "CENTER", 29, -195)
supportCheck:SetPoint("CENTER", optionsPanel, "CENTER", 82, -195)

clientName:SetPoint("CENTER", optionsPanel, "CENTER", 0, -130)
clientName:SetLayer(6)
clientName:SetFontSize(16)
clientPrestige:SetPoint("CENTER", optionsPanel, "CENTER", 0, -90)
clientPrestige:SetLayer(6)
clientPrestige:SetFontSize(28)
clientNoteLabel:SetText("Set your personal note:")
clientNoteLabel:SetPoint("CENTER", optionsPanel, "CENTER", 0, -10)
clientNoteLabel:SetLayer(6)
clientNoteLabel2:SetText("This will be broadcasted to other users")
clientNoteLabel2:SetPoint("CENTER", optionsPanel, "CENTER", 0, 50)
clientNoteLabel2:SetLayer(6)
clientNote:SetPoint("CENTER", optionsPanel, "CENTER", 0, 20)
clientNote:SetWidth(230)
clientNote:SetLayer(6)
clientNote:SetBackgroundColor((87/255),(87/255),(87/255),0.8)

tankIcon:SetLayer(6)
tankIcon:SetWidth(42)
tankIcon:SetWidth(43)
tankIcon:SetTexture("Synergy", "img/tank_icon.png")
tankCheck:SetLayer(6)
healerIcon:SetLayer(6)
healerIcon:SetWidth(42)
healerIcon:SetWidth(43)
healerIcon:SetTexture("Synergy", "img/healer_icon.png")
healerCheck:SetLayer(6)
damageIcon:SetLayer(6)
damageIcon:SetWidth(42)
damageIcon:SetWidth(43)
damageIcon:SetTexture("Synergy", "img/damage_icon.png")
damageCheck:SetLayer(6)
supportIcon:SetLayer(6)
supportIcon:SetWidth(42)
supportIcon:SetWidth(43)
supportIcon:SetTexture("Synergy", "img/support_icon.png")
supportCheck:SetLayer(6)

Syn_minimapIcon:SetTexture("Synergy", "img/icon.png")
Syn_minimapIcon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)
Syn_minimapIcon:SetLayer(3)
Syn_minimapIcon:SetWidth(42)
Syn_minimapIcon:SetHeight(32)

local playerGrid = DataGrid("Syn.UI.PlayerGrid", mainWindow)
playerGrid:SetPoint("CENTER", mainWindow, "CENTER", -130, 5)
playerGrid:SetPadding(1, 1, 1, 45)
playerGrid:SetHeadersVisible(true)
playerGrid:SetRowHeight(62)
playerGrid:SetRowMargin(2)
playerGrid:SetUnselectedRowBackgroundColor({0.2, 0.2, 0.2, 0.25})
playerGrid:SetSelectedRowBackgroundColor({0.6, 0.6, 0.6, 0.25})
playerGrid:SetLayer(5)
playerGrid:SetHeight(546)
playerGrid:SetWidth(698)
playerGrid:AddColumn("player", "Player", SearchCellType, 100, 3, "player", true)
playerGrid:AddColumn("level", "Level", "Text", 50, 1, "level", true, { Alignment = "center" })
playerGrid:AddColumn("role", "Role", "Text", 50, 1, "role", true, { Alignment = "center" })
playerGrid:AddColumn("prestige", "Prestige", "Text", 50, 1, "prestige", true, { Alignment = "center" })
playerGrid:AddColumn("note", "Note", "Text", 200, 1, "note", true, { Alignment = "left" })
playerGrid:GetInternalContent():SetBackgroundColor(0, 0.05, 0.05, 0.5)
playerGrid:SetLoadingBarEnabled(true)

local values = {}
values[1] = { player = "Zanderwar@Wolfsbane", level = "60", role = "THDS", prestige = "33", note = "Great player, full myrm" }
values[2] = { player = "col1", level = "col2", role = "col3", prestige = "col4", note = "col5" }
values[3] = { player = "col1", level = "col2", role = "col3", prestige = "col4", note = "col5" }
playerGrid:SetData(values, nil)
	
	
unit = Inspect.Unit.Detail("player")
prestige = Inspect.Pvp.Prestige()

if unit and prestige then
	local playerLevel = "~"
	local playerName = unit.name
	playerLevel = unit.level
	if playerLevel == nil then playerLevel = "N/A" end
	playerTitleLabel = playerName.."("..playerLevel..")"
	clientName:SetText(playerTitleLabel)
	clientPrestige:SetText("Prestige "..prestige.rank)
end

local function AttachDragFrame(parent, name, layer, button)

	if not name then name = "" end
	if not layer then layer = 0 end
	if not button then button = "LeftDown" end
	
	local DragFrame = UI.CreateFrame("Frame", name.."_DragFrame", parent)
	DragFrame:SetPoint("TOPLEFT", parent, "TOPLEFT")
	DragFrame:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT")
	DragFrame.parent = parent
	DragFrame.MouseDown = false
	DragFrame:SetLayer(layer)
	
	if button == "LeftDown" then
		function DragFrame.Event:LeftDown()
			self.MouseDown = true
			mouseData = Inspect.Mouse()
			self.MyStartX = self.parent:GetLeft()
			self.MyStartY = self.parent:GetTop()
			self.StartX = mouseData.x - self.MyStartX
			self.StartY = mouseData.y - self.MyStartY
			tempX = self.parent:GetLeft()
			tempY = self.parent:GetTop()
			tempW = self.parent:GetWidth()
			tempH =	self.parent:GetHeight()
			self.parent:ClearAll()
			self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", tempX, tempY)
			self.parent:SetWidth(tempW)
			self.parent:SetHeight(tempH)
		end
		function DragFrame.Event:MouseMove(mouseX, mouseY)
			if self.MouseDown then
				self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", (mouseX - self.StartX), (mouseY - self.StartY))
			end
		end
		function DragFrame.Event:LeftUp()
			if self.MouseDown then
				self.MouseDown = false
			end
		end
	elseif button == "RightDown" then
		function DragFrame.Event:RightDown()
			self.MouseDown = true
			mouseData = Inspect.Mouse()
			self.MyStartX = self.parent:GetLeft()
			self.MyStartY = self.parent:GetTop()
			self.StartX = mouseData.x - self.MyStartX
			self.StartY = mouseData.y - self.MyStartY
			tempX = self.parent:GetLeft()
			tempY = self.parent:GetTop()
			tempW = self.parent:GetWidth()
			tempH =	self.parent:GetHeight()
			self.parent:ClearAll()
			self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", tempX, tempY)
			self.parent:SetWidth(tempW)
			self.parent:SetHeight(tempH)
		end
		function DragFrame.Event:MouseMove(mouseX, mouseY)
			if self.MouseDown then
				self.parent:SetPoint("TOPLEFT", UIParent, "TOPLEFT", (mouseX - self.StartX), (mouseY - self.StartY))
			end
		end
		function DragFrame.Event:RightUp()
			if self.MouseDown then
				self.MouseDown = false
			end
		end

	end
	
	return DragFrame
end

local function SaveVariables(handle, addon)
	if addon == "Synergy" then
		Syn_framePosX = math.floor(mainWindow:GetLeft())
		Syn_framePosY = math.floor(mainWindow:GetTop())
		Syn_iconX = math.floor(Syn_minimapIcon:GetLeft())
		Syn_iconY = math.floor(Syn_minimapIcon:GetTop())
				
		if toggle_state == 1 then Syn_visible = 1 else Syn_visible = 0 end
		
	end
end

local function InitVariables(handle, addon)
	if addon == "Synergy" then
		local Syn_frameY = 350
		local Syn_frameY = 350
		local Syn_mapIconX = 400
		local Syn_mapIconY = 400
		
		if visible == 0 then context:SetVisible(false) end
		
		if Syn_framePosX then
			Syn_frameX = Syn_framePosX
		end
		
		if Syn_framePosY then
			Syn_frameY = Syn_framePosY
		end
		
		if Syn_iconX then
			Syn_mapIconX = Syn_iconX
		end
		
		if Syn_iconY then
			Syn_mapIconY = Syn_iconY
		end

		
		mainWindow:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Syn_frameX, Syn_frameY)
		Syn_minimapIcon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", Syn_mapIconX, Syn_mapIconY)
		
		
		
	end
end



local Syn_mapicon = AttachDragFrame(Syn_minimapIcon, "WFWMapIcon", 10, "RightDown")
Syn_mapicon:SetVisible(true)
Syn_mapicon:EventAttach(Event.UI.Input.Mouse.Left.Click, function(self, h)
	if (toggle_state == 1) or toggle_state == nil and Syn_visible == 1 then
		toggle_state = 0
		Syn_visible = 0
		mainWindow:SetVisible(false)
		Command.Console.Display("general", false, "Synergy has been hidden.", true)
	else
		toggle_state = 1
		Syn_visible = 1
		mainWindow:SetVisible(true)
		Command.Console.Display("general", false, "Synergy is now showing.", true)
	end
end, "Event.UI.Input.Mouse.Left.Click")

Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, SaveVariables, "SaveVariables")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, InitVariables, "InitVariables")